(* Copyright (C) 2017 Daniel Wyckoff *)
(*This file is part of BooleanAlgebrasIntro2.

BooleanAlgebrasIntro2 is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

BooleanAlgebrasIntro2 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with BooleanAlgebrasIntro2.  If not, see <http://www.gnu.org/licenses/>.*)

(*Version 0.3 bool2 -- certified -- Coq 8.4 pl4.*)


Require Import SetUtilities.
Require Import SetUtilities2.
Require Import SetUtilities2_5.
Require Import ListUtilities.
Require Import ListUtilities2.
Require Import EqDec.
Require Import LogicUtilities.
Require Import ArithUtilities.

Lemma list_constructive_definite_description :
  forall {T:Type} (pfd:type_eq_dec T) (l:list T) (P:T->Prop),
    (exists x:T, In x l /\ P x) ->
    {b:T | In b l /\ P b}.
  intros T hd l P h1.
  pose (list_to_seg_one_t_fun' (list_singularize hd l)) as f.
  assert (h2: exists x:sig_set (list_to_set l), In (proj1_sig x) l /\ P (proj1_sig x)).
    destruct h1 as [x h1]. destruct h1 as [h1 h2].
    rewrite list_to_set_in_iff in h1.
    exists (exist _ _ h1); simpl. 
    rewrite <- list_to_set_in_iff in h1.
    split; auto.
  pose proof (card_fun1_length_eq hd l) as h3.
  assert (h4:forall x:sig_set (seg (card_fun1 (list_to_set l))),
               1 <= S (proj1_sig x) <= length (list_singularize hd l)).
    intro x. destruct x as [x h5]. simpl. 
    destruct h5 as [h5]. 
    rewrite <- h3. omega.
  pose (fun x:sig_set (seg (card_fun1 (list_to_set l))) =>
          f (exist _ _ (h4 x))) as f'.
  assert (h6:forall x:{x0 : T | In x0 (list_singularize hd l)},
               Inn (list_to_set l) (proj1_sig x)).
    intro x. destruct x as [x h5]. simpl.
    rewrite <- list_singularize_in_iff in h5.
    rewrite <- list_to_set_in_iff.
    assumption.
  pose (fun x:sig_set (seg (card_fun1 (list_to_set l))) =>
            exist _ _ (h6 (f' x))) as f''.
  pose proof (finite_constructive_definite_description' _ (list_to_set_finite l) f'') as h7.
  apply h7; auto.
  apply inj_impl_bij_sig_set_eq_card.
  apply finite_seg. apply list_to_set_finite.
  rewrite card_fun1_seg_eq; auto.
  pose proof (list_to_seg_one_t_fun_no_dup_inj' (list_singularize hd l) (no_dup_list_singularize hd _)) as h8.
  red in h8. red.
  intros x y h9.
  destruct x as [x h10], y as [y h11].
  unfold f'' in h9.
  apply exist_injective in h9. apply proj1_sig_injective in h9.
  unfold f', f in h9.
  apply h8 in h9.
  apply exist_injective in h9.
  simpl in h9.
  apply S_inj in h9.
  subst.
  apply proj1_sig_injective; auto.
Qed.
